#!/usr/bin/perl
use Tie::File;
use File::Copy;
use lib ($ARGV[-1]); # SET THE LIBRARY PATH
$LibraryPath = pop(@ARGV); # POP IT OFF FOR FUTURE USE
$LogFile = $LibraryPath . "index.html";
$TableSort = $LibraryPath . "javascripts/sorttable.js";
$PopUps = $LibraryPath . "javascripts/PopUps.js";
$UseFile = $LibraryPath . ".UserHistory.txt";
$i=0;
open(F,">$LogFile");
if (-e $UseFile){
	tie @array, 'Tie::File', $UseFile;
	$LastPath = $array[0];
	if ($LastPath ne $LibraryPath){
		$LastPath = $array[1];
		if ($LastPath eq ""){
			$array[1] = $LibraryPath;
		}else{
			if ($LastPath ne $LibraryPath){
				$LastPath = $array[2];
				if ($LastPath eq ""){
					$array[2] = $LibraryPath;
				}else{
					if ($LastPath ne $LibraryPath){
						print F "It appears that you have exceeded the maximum number of installations for this license.  If you believe that you have received this message in error, please contact us.  You are limited to installing this software on a maximum of 3 computers.  You may also receive this error if you have installed this program in multiple locations on the same computer.";
						close (F);
					}
				}
			}
		}
	} 	
}else{
	tie @array, 'Tie::File', $UseFile;
	$array[0] = $LibraryPath;
}
untie @array;

$i=0;



print F "<html>\n";
print F "<head>\n";

print F "<script src=\"$PopUps\"></script>\n";

print F "<title>MacSequenceView\&copy\; Report</title>\n";
print F "<link href=\"style.css\" rel=\"stylesheet\" type=\"text/css\" media=\"screen\" />\n"; 
print F "</head>\n\n";
print F "<body>\n";
print F "<div id=\"wrapper\">\n";
print F "	<div id=\"menu\">\n";
print F "		<ul>\n";
print F "			<li><a href=\"http://gotoes.org/sales/Mac_Sequence_Viewer/\">BUY</a>\n";
print F "			<li><a href=\"file://$LibraryPath" . "help.html\" title=\"Click Here for help with this program\">HELP</a></li>\n";
print F "			<li><a href=\"file://$LibraryPath" . "FASTA.txt\" title=\"Click Here to download a FASTA file of all your Sequences\">FASTA</a></li>\n";
print F "			<li><a href=\"http://gotoes.org/sales/Mac_Sequence_Viewer/BLAST.html\">BLAST</a></li>\n";
print F "			<li><a href=\"http://gotoes.org/sales/Mac_Sequence_Viewer/VecScreen.html\">VecScreen</a></li>\n";
print F "		</ul>\n";
print F "	</div>\n";
print F "	<div id=\"logo\">\n";
print F "		<h1><a href=\"http://gotoes.org/sales/Mac_Sequence_Viewer/\"><img src=\"How_To_Open_AB1_Files.png\" border=\"0\" align=\"left\"> MacSequenceView \&copy\;</a></h1>\n";
print F "		<h2>By GOTOES.ORG</h2>\n";
print F "	</div>\n";
print F "	<hr>\n";
print F "	<div id=\"page\">\n";
print F "		<div id=\"content\">\n";
print F "			<div class=\"post\">\n";
print F "				<h2 class=\"title\"><a href=\"\#\">Your DNA Sequence Report</a></h2>\n";
print F "				<div class=\"entry\">\n";




print F "\t\t\t\t<table cellpadding=2 cellspacing=3 border=1 width=778 class=sortable>\n";
print F "\t\t\t\t<tr bgcolor=\"\#B6B9A8\">\n";
print F "\t\t\t\t\t<th title=\"Sort Number\">No.</th>\n";
print F "\t\t\t\t\t<th>Cap<br>No.</th>\n";
print F "\t\t\t\t\t<th>Sample<br>Name</th>\n";
print F "\t\t\t\t\t<th>Sample<br>Comment</th>\n";
print F "\t\t\t\t\t<th>ABI<br>Quality<br>Score</th>\n";
print F "\t\t\t\t\t<th>Ratio<br>Of Base<br>Qualities</th>\n";
print F "\t\t\t\t\t<th>Signal to<br>Noise Ratio</th>\n";
print F "\t\t\t\t\t<th>Read<br>Length</th>\n";
print F "\t\t\t\t\t<th>Base<br>Spacing</th>\n";
print F "\t\t\t\t</tr>\n";


use Bio::Trace::ABIF;
$abif = Bio::Trace::ABIF->new();

foreach $FileToSort(@ARGV){
	$abif->open_abif($FileToSort);
	$CapillaryNumber = $abif->capillary_number();
	$ContainerName = $abif->container_name();
	if ($CapillaryNumber < 10){
		$CapillaryNumber = "0" . $CapillaryNumber;
	}
	$abif->close_abif();
	$ConCatName = $ContainerName . $CapillaryNumber;
	$HashOfFiles{ $ConCatName } = $FileToSort;
}

foreach $key(sort keys %HashOfFiles){
	push (@ListOfFiles, $HashOfFiles{$key});
}

$PathToFASTA = $LibraryPath . "FASTA.txt";
open(FASTA,">$PathToFASTA");
foreach $LineRead(@ListOfFiles){
	$abif->open_abif($LineRead);
	$Comment = $abif->comment();
	$ContainerName = $abif->container_name();
	$LengthOfRead = $abif->sequence_length();
	$NumLowQualityBases = $abif->num_low_quality_bases(20);
	$NumMediumQualityBases = $abif->num_medium_quality_bases(21,40);
	$NumHighQualityBases = $abif->num_high_quality_bases(41);
	$SampleScore = $abif->sample_score();
	$AvgSignalToNoiseRatio = $abif->avg_signal_to_noise_ratio();
	$CapillaryNumber = $abif->capillary_number();
	$SampleName = $abif->sample_name();
	$Spacing = $abif->base_spacing();
	$Sequence = $abif->sequence();
	$abif->close_abif();

	$i++;
	# MAKE GRAPHICAL REPRESENTATIONS OF QUALITY
	$NumLowQualityBases = $NumLowQualityBases + 1;
	$LengthOfRead = $LengthOfRead + 1;
	$NumMediumQualityBases = $NumMediumQualityBases + 1;
	$NumHighQualityBases = $NumHighQualityBases + 1;
	$PercentLow = int(($NumLowQualityBases / $LengthOfRead)*100);
	$PercentMed = int(($NumMediumQualityBases / $LengthOfRead)*100);
	$PercentHigh = int(($NumHighQualityBases / $LengthOfRead)*100);
	$LOR = int($LengthOfRead / 10);
	$TableGraph = "<TABLE bgColor=red height=5 width=$PercentLow cellSpacing=0 cellPadding=0 border= 0><TR><TD></TD></TR></TABLE>";
	$TableGraph .= "<TABLE bgColor=yellow height=5 width=$PercentMed cellSpacing=0 cellPadding=0 border= 0><TR><TD></TD></TR></TABLE>";
	$TableGraph .= "<TABLE bgColor=green height=5 width=$PercentHigh cellSpacing=0 cellPadding=0 border= 0><TR><TD></TD></TR></TABLE>";
	$LengthOfReadGraph = "<TABLE bgColor=blue height=5 width=$LOR cellSpacing=0 cellPadding=0 border= 0><TR><TD></TD></TR></TABLE>";
	$LengthOfRead = $LengthOfRead - 1; #BRING IT BACK DOWN AFTER MATH IS DONE
	$OAvgLengthOfRead += $LengthOfRead;
	$OAvgSampleScore += $SampleScore;
	$OAvgSignalToNoiseRatio += $AvgSignalToNoiseRatio;

	$QualityBG = "Green";
	if ($SampleScore < 40){
		$QualityBG = "Yellow";
	}
	if ($SampleScore < 20){
		$QualityBG = "Red";
	}
	if ($AvgSignalToNoiseRatio < 25){
		$StoNColor = "RED";
	}
	if (($AvgSignalToNoiseRatio > 25)&&($AvgSignalToNoiseRatio < 100)){
		$StoNColor = "YELLOW";
	}
	if ($AvgSignalToNoiseRatio > 100){
		$StoNColor = "GREEN";
	}
	if (($Spacing > 13)||($Spacing < 11)){
		$SpacingColor = "RED";
	}else{
		$SpacingColor = "GREEN";
	}
	$Spacing = int($Spacing);
	$SampleScore = int($SampleScore);
	$AvgSignalToNoiseRatio = int($AvgSignalToNoiseRatio);
	$RowBGColor = "\#EDFBD2";
	$PathToViewer = $LibraryPath . "$i.html";


	print F "\t\t\t\t<tr align=\"center\" bgcolor=$RowBGColor>\n";
	print F "\t\t\t\t\t<td>$i</td>\n";
	print F "\t\t\t\t\t<td>$CapillaryNumber</td>\n";
	print F "\t\t\t\t\t<td><a href=\"javascript:popUpSize('$PathToViewer',500,300)\">$SampleName</a></td>\n";
	print F "\t\t\t\t\t<td>$Comment</td>\n";
	print F "\t\t\t\t\t<td bgcolor=$QualityBG>$SampleScore</td>\n";
	print F "\t\t\t\t\t<td align=\"left\">$TableGraph</td>\n";
	print F "\t\t\t\t\t<td bgcolor=$StoNColor>$AvgSignalToNoiseRatio</td>\n";
	print F "\t\t\t\t\t<td align=\"left\">$LengthOfReadGraph<font size=1>$LengthOfRead</font></td>\n";
	print F "\t\t\t\t\t<td bgcolor=$SpacingColor>$Spacing</td>\n";
	print F "\t\t\t\t</tr>\n";


	#MAKE THE VIEWER FILE

	$CodeBasePath = "file://" . $LibraryPath . "SQPR";
	$NewFileName = $LibraryPath . "SQPR/$i" . ".ab1";
	copy ($LineRead,$NewFileName);
	open(VF,">$PathToViewer");
	print VF "<html>\n";
	print VF "<head>\n";
	print VF "<meta http-equiv=\"Content-Language\" content=\"en-us\">\n";
	print VF "<meta http-equiv=\"Content-Type\" content=\"text/html\; charset=windows-1252\">\n";
	print VF "<title>$SampleName</title>\n";
	print VF "</head>\n";
	print VF "<body><center>\n";
	print VF "<h2>$SampleName</h2><hr>\n";
	print VF "<font size=\"1\"><i>Firefox Users May need to click once in this window after applet is loaded</i></font>\n";
	print VF "<script language=\"JavaScript\">\n";
	print VF "	var detect = navigator.userAgent.toLowerCase()\;\n";
	print VF "</script>\n\n";
	print VF "	<applet codebase='$CodeBasePath' code='ChromatogramApplet.class' width=450 height=200>\n";
	print VF "	<param name='file' value='$NewFileName'>\n";
	print VF "	</applet>\n";
	print VF "</center></body>\n";
	print VF "</html>\n";
	close (VF);

	# MAKE THE FASTA FILE
	print FASTA ">$SampleName\n";
	print FASTA "$Sequence\n\n";
}

close (FASTA);
$OAvgLengthOfRead = int($OAvgLengthOfRead / $i);
$OAvgSampleScore = int($OAvgSampleScore / $i);
$OAvgSignalToNoiseRatio = int($OAvgSignalToNoiseRatio / $i);


print F "\t\t\t\t</table>\n";
print F "				</div>\n";
print F "				<p class=\"meta\"><span class=\"posted\">Analyzed <b>$i</b> Results | Avg. Read Length: $OAvgLengthOfRead | Avg. Score: $OAvgSampleScore | Avg. Sig. to Noise: $OAvgSignalToNoiseRatio</span></p>\n";
print F "			</div>\n";
print F "		</div>\n";		
print F "	</div>\n";
print F "	<div id=\"footer\">\n";
print F "		<p>\&copy\; 2008 <a href=\"http://gotoes.org/\">GOTOES.ORG</a></p>\n";
print F "	</div>\n";
print F "</div>\n";



if ($i < 200){
	print F "<script src=\"$TableSort\"></script>\n";
}








print F "</body>";
print F "</html>";

close (F);